<script setup lang="ts">
import { isClient } from '@vueuse/core'
import { useThemeVars } from 'naive-ui'
import { parseColor, theme } from 'unocss/preset-mini'

const { height } = useWindowSize()

watch(height, (v) => {
  setCssVar('--screen', `${v}px`)
}, { immediate: true })

const themeVars = useThemeVars()

watch(themeVars, (vars) => {
  const config = {
    '--n-primary': 'primaryColor',
    '--n-info': 'infoColor',
    '--n-success': 'successColor',
    '--n-warning': 'warningColor',
    '--n-error': 'errorColor',
  } as const

  Object.entries(config).forEach(([k, v]) => {
    const value = parseColor(`[${vars[v]}]`, theme)?.cssColor?.components.join(' ')

    if (value)
      setCssVar(k, value)
  })
}, { immediate: true })

function setCssVar(property: string, value: string | null) {
  if (isClient)
    document.documentElement.style.setProperty(property, value)
}
</script>

<template>
  <slot></slot>
</template>
